# ssh-warm-welcome

<img align="right" width="150" src="./logo.png"/>

SSH as a publishing interface :tada:

`ssh-warm-welcome` serves a [TUI] for reading markdown documents via a built-in
SSH server. In the context of a [pubnix] or [femserver] it can be a convenient
way to publish documentation to a general public via the terminal instead of
the browser. It's designed to be easy to use for beginners: no user accounts or
SSH keys are required, simply use your standard `/usr/bin/ssh` command to
connect & start reading.

Here's a little demo video: [`vvvvvvaria.org/~decentral1se/sshww/demo.mp4`](https://vvvvvvaria.org/~decentral1se/sshww/demo.mp4)

[pubnix]: https://tilde.town/~cmccabe/online-communities.html
[femserver]: https://gendersec.tacticaltech.org/wiki/index.php/Servers:_From_autonomous_servers_to_feminist_servers
[TUI]: https://en.wikipedia.org/wiki/Text-based_user_interface

## Quickstart

Download `ssh-warm-welcome` like so.

(only `x86_64` is available right now but we can build more if you need it)

```bash
curl https://vvvvvvaria.org/~decentral1se/sshww/sshww -o sshww
chmod +x sshww
```

Write your warm welcome home page in markdown:

```
mkdir -p warm-welcome
echo "# hello, world!\n\nwelcome, welcome" > warm-welcome/welcome.md
```

Then turn on the built-in SSH server:

```
./sshww
2022/04/03 00:11:39 warm welcome waiting on port :1312
```

And from another terminal, connect with your SSH client:

```
ssh -p 1312 localhost
```

That's it!

## Configure

* `sshww` reads markdown files from a folder named `warm-welcome` in the
  current working directory. Any file it finds there will be included as a menu
  item in the warm welcome environment. `welcome.md` is the only required file,
  everything else is optional. Up to 10 markdown files are supported.

## Acknowledgements

* [`egonelbre/gophers`](https://github.com/egonelbre/gophers) for the rad logo
* [`charm.sh`](https://github.com/charmbracelet) for new-wave command line glamour

## License

<a><img src="https://www.gnu.org/graphics/gplv3-or-later.png"/></a>
